<?php 
// Welcome to 乐众系统&IDC财务管理系统
// Copyright (c)  http://www.lzsys.com/ All rights reserved.
// Business authorization email server@lzsys.com
// 欢迎使用乐众系统&IDC财务管理系统
// [实名应用 功能模块]
$api_config = $plugin->api_config();
$addons_config = $plugin->addons_config();
$asset_data = $plugin->asset_data();
$post = $plugin->ide->php->post();
$get = $plugin->ide->php->get();
$app_data = $plugin->ide->lzsys_system->app_data();
$hash = $app_data['app_hash']; //获取加密混合值

$addon_path = $addons_config['path']; // 获得 应用目录名称
$api_config['remark']['alikey'] = str_replace(" ", "+", $api_config['remark']['alikey']);
$api_config['remark']['rsakey'] = str_replace(" ", "+", $api_config['remark']['rsakey']);
// -----------上面是固定数据，不懂不要修改
// 该应用在安装时 需要创建一张表  lzsys_xueauth_user_authlog 用于储存客户实名记录信息
// 表的格式必须为 lzsys_应用目录名称_user_authlog  如 应用目录名称是 aliyun 则表名 lzsys_aliyun_user_authlog
// 但是你执行表操作的时候 不需要输入 lzsys_ 表前缀有系统自动判断
// 如查询表 $plugin->ide->mysql->get_db("user_id='1' and app_id='10016'","xueauth_user_authlog");
// 表的字段根据配置文件中 添加实名所需的身份信息记录，（验证码无需记录）

// 每个实名应用都应当创建属于自己的实名记录信息表
if ($plugin->ide->php->session("user_id") == "") {
    exit("当前客户未登录");
} 
if (!$plugin->ide->php->session("user_id")) {
    exit("当前客户未登录");
} 
$auth_money = $api_config['remark']['money']; // 实名价格
$user_datas = $plugin->ide->mysql->get_db("user_id='" . $plugin->ide->php->session("user_id") . "' and app_id='" . $plugin->ide->lzsys_system->app_id() . "'", "user");

if (!$user_datas) {
    exit("当前客户异常");
} 

if ($user_datas['balance'] < $auth_money) {
    exit("实名认证需要花费 " . $auth_money . "元, 你的余额不足 请先 <a href='/index.php/user/pay' style='color:blue'>充值</a>");
} 

/**
 * 检查验证码是否超时 (自定义方法 无规律 开发者也可以自定义)
 */
function xueauth_vcode_time($plugin) {
    if ($plugin->ide->php->session("vcode_time") <> "") {
        $vcode_time = $plugin->ide->php->session("vcode_time");
        $now_time = time();
        $times = $now_time - $vcode_time;
        if ($times > 600) {
            exit("验证码已过期");
        } 
    } 
} 
/**
 * 生成短信验证码并且发送 (自定义方法 无规律 开发者也可以自定义)
 */
function xueauth_auth_code($plugin, $user, $type) {
    $user['code'] = $plugin->ide->lzsys_system->number(4);
    $user['code_time'] = "10分钟";
    $plugin->ide->php->session("vcode", $user['code']); //将验证码储存起来  验证时需要用到
    $plugin->ide->php->session("mobile", $user['mobile']); //将手机号储存起来  验证时需要用到
    return $plugin->ide->lzsys_system->run_sms($plugin->ide(), $user, $type);
} 
/**
 * 检查发送条件是否满足 (自定义方法 无规律 开发者也可以自定义)
 */
function xueauth_get_time($plugin) {
    if ($plugin->ide->php->session("vcode_time") <> "") {
        $vcode_time = $plugin->ide->php->session("vcode_time");
        $now_time = time();
        $times = $now_time - $vcode_time;
        if ($times < 60) {
            exit("你发送过于频繁，请60秒后再试"); 
            // 如果你是开发者 可以再次进行IP限制 手机号限制 浏览器限制等
            // 也可以在短信应用中进行限制 总而言之 方法很多。
        } 
    } 
} 
/**
 * get_sms_code 收到发送短信验证码请求   固定方法
 */
if ($get['act'] == "get_sms_code") {
    if ($post['tel'] == "") {
        exit("请输入手机号");
    } 
    if ($post['sms_type'] == "") {
        $post['sms_type'] = "auth_code";
    } 
    xueauth_get_time($plugin);
    $user['mobile'] = $post['tel']; //获得接收验证码的手机号
    $data = xueauth_auth_code($plugin, $user, $post['sms_type']);
    $data = $plugin->ide->lzsys_system->_array($data);
    if ($data['status'] == true) {
        $plugin->ide->php->session("vcode_time", time()); //记录验证码发送时间
        exit("True"); //成功返回True
    } 
    exit($data['msg']); // 返回失败信息
} 

function auth_initialize($api_config, $name, $card_num, $tel, $plugin) {
    require_once ('plugin/auth/alipayauth/aop/AopClient.php');
    require_once ('plugin/auth/alipayauth/aop/request/AlipayUserCertifyOpenInitializeRequest.php'); //身份认证初始化服务
    require_once ('plugin/auth/alipayauth/aop/request/AlipayUserCertifyOpenCertifyRequest.php'); //身份认证开始认证
    require_once ('plugin/auth/alipayauth/aop/request/AlipayUserCertifyOpenQueryRequest.php'); //身份认证记录查询 
    // alipay.user.certify.open.initialize
    $aop = new AopClient ();
    $aop->gatewayUrl = 'https://openapi.alipay.com/gateway.do';
    $aop->appId = $api_config['remark']['appid'];
    $aop->rsaPrivateKey = $api_config['remark']['rsakey'];
    $aop->alipayrsaPublicKey = $api_config['remark']['alikey'];
    $aop->apiVersion = '1.0';
    $aop->signType = 'RSA2';
    $aop->postCharset = 'utf-8';
    $aop->format = 'json';
    $params = array();
    $params = [
    'outer_order_no' => md5(time() . rand()), // 商户请求的唯一标识，最大32位
    'biz_code' => 'FACE',
    'identity_param' => [
    'identity_type' => 'CERT_INFO',
    'cert_type' => 'IDENTITY_CARD',
    'cert_name' => $name,
    'cert_no' => $card_num,
    'phone_no' => $tel,
    ],
    'merchant_config' => [

    'return_url' => $plugin->ide->lzsys_system->get_http() . '//' . $plugin->ide->lzsys_system->get_domain() . '/index.php/user/auth', // 回跳的目标地址 //b637a7e76dcf34e0bd8fd56a716df30b
    ]
    ];
    $request = new AlipayUserCertifyOpenInitializeRequest();
    $request->setBizContent(json_encode($params)); //$params转化为json
    $result = $aop->execute($request);
    $responseNode = str_replace(".", "_", $request->getApiMethodName()) . "_response";
    $resultCode = $result->$responseNode->code;
    $resultmsg = $result->$responseNode->msg;
    if (!empty($resultCode) && $resultCode == 10000) {
        return $result->$responseNode->certify_id; //本次申请操作的唯一标识
    } 
    exit("错误码：" . $resultCode . ",信息：" . $resultmsg);
} 

function auth_certify($certify_id, $api_config) {
    require_once ('plugin/auth/alipayauth/aop/AopClient.php');
    require_once ('plugin/auth/alipayauth/aop/request/AlipayUserCertifyOpenInitializeRequest.php'); //身份认证初始化服务
    require_once ('plugin/auth/alipayauth/aop/request/AlipayUserCertifyOpenCertifyRequest.php'); //身份认证开始认证
    require_once ('plugin/auth/alipayauth/aop/request/AlipayUserCertifyOpenQueryRequest.php'); //身份认证记录查询
    $aop = new AopClient ();
    $aop->gatewayUrl = 'https://openapi.alipay.com/gateway.do';
    $aop->appId = $api_config['remark']['appid'];
    $aop->rsaPrivateKey = $api_config['remark']['rsakey'];
    $aop->alipayrsaPublicKey = $api_config['remark']['alikey'];
    $aop->apiVersion = '1.0';
    $aop->signType = 'RSA2';
    $aop->postCharset = 'utf-8';
    $aop->format = 'json';
    $params = array();
    $params['certify_id'] = $certify_id; //上一步获取的操作的唯一标识
    $request = new AlipayUserCertifyOpenCertifyRequest();
    $request->setBizContent(json_encode($params));
    $result = $aop->pageExecute($request, 'GET');
    return htmlspecialchars($result);
} 
function auth_query($certify_id, $api_config) {
    require_once ('plugin/auth/alipayauth/aop/AopClient.php');
    require_once ('plugin/auth/alipayauth/aop/request/AlipayUserCertifyOpenInitializeRequest.php'); //身份认证初始化服务
    require_once ('plugin/auth/alipayauth/aop/request/AlipayUserCertifyOpenCertifyRequest.php'); //身份认证开始认证
    require_once ('plugin/auth/alipayauth/aop/request/AlipayUserCertifyOpenQueryRequest.php'); //身份认证记录查询
    $aop = new AopClient ();
    $aop->gatewayUrl = 'https://openapi.alipay.com/gateway.do';
    $aop->appId = $api_config['remark']['appid'];
    $aop->rsaPrivateKey = $api_config['remark']['rsakey'];
    $aop->alipayrsaPublicKey = $api_config['remark']['alikey'];

    $aop->apiVersion = '1.0';
    $aop->signType = 'RSA2';
    $aop->postCharset = 'utf-8';
    $aop->format = 'json';
    $params = array();
    $params['certify_id'] = $certify_id; //上一步获取的操作的唯一标识
    $request = new AlipayUserCertifyOpenQueryRequest();
    $request->setBizContent(json_encode($params));
    $result = $aop->execute($request);
    $responseNode = str_replace(".", "_", $request->getApiMethodName()) . "_response";
    $resultCode = $result->$responseNode->code;
    if (!empty($resultCode) && $resultCode == 10000) {
        if ($result->$responseNode->passed == 'T') {
            return "True";
        } 
    } 
    return "错误信息：" . $result->$responseNode->msg . $result->$responseNode->fail_reason . $result->$responseNode->passed;
} 

/**
 * ------查询实名结果
 */
if ($get['act'] == "auth_query") {
    $app_id = $plugin->ide->lzsys_system->app_id();
    $user_id = $plugin->ide->php->session("user_id");
    $auth_data = $plugin->ide->mysql->get_db("user_id='$user_id' and app_id='$app_id'", "alipayauth_user_authlog");

    if ($plugin->ide->mysql->get_db("user_id='$user_id' and app_id='$app_id' and auth='1'", "user")) {
        exit("已经实名过");
    } 

    $certify_id = $auth_data['certify_id'];
    if($certify_id=="1"){
		exit("未找到正确的业务标识");
	}
    $query_id = auth_query($auth_data['certify_id'], $api_config);
    if ($query_id == "True") {
        $name = $auth_data['name'];
        $card_num = $auth_data['card_num'];
        $tel = $auth_data['tel'];
        $api_id = $api_config['api_id']; 
        // 认证成功 执行数据修改 如 扣除客户余额， 写财务日志，修改实名状态等
        // 执行修改实名状态
        $plugin->ide->mysql->up_db("auth='1',auth_api='$api_id',name='$name'", "user", "user_id='" . $plugin->ide->php->session("user_id") . "' and app_id='" . $plugin->ide->lzsys_system->app_id() . "'"); 
        // 执行客户余额扣除
        $plugin->ide->mysql->up_db("balance=balance-$auth_money", "user", "user_id='" . $plugin->ide->php->session("user_id") . "' and app_id='" . $plugin->ide->lzsys_system->app_id() . "'"); 
        // 执行写财务记录
        $pay_name = $api_config['name']; //渠道名称
        $get_orders = $plugin->ide->lzsys_system->get_orders();
        $stop_money = $user_datas[balance] - $auth_money;
        $sql_querys = "null,'$get_orders','$user_datas[user_id]','$user_datas[balance]','$auth_money','$stop_money','2','" . time() . "','" . time() . "','1','$pay_name','" . $plugin->ide->lzsys_system->app_id() . "'";
        $plugin->ide->mysql->add_db($sql_querys, "shop_finance"); 
        // 写实名信息记录日志
        $app_id = $plugin->ide->lzsys_system->app_id();
        $update_time = time();
        $create_time = time();
        $user_id = $plugin->ide->php->session("user_id");

        $auth_log = $plugin->ide->mysql->get_db("user_id='$user_id' and app_id='$app_id'", "alipayauth_user_authlog");

        if ($auth_log) {
            // 已经存在记录 执行更新
            $plugin->ide->mysql->up_db("certify_id='1',name='$name',tel='$tel',card_num='$card_num',update_time='$update_time'", "alipayauth_user_authlog", "user_id='$user_id' and app_id='$app_id'");
        } else {
            // 不存在记录 执行写入
            $plugin->ide->mysql->add_db("null,'$user_id','$create_time','$update_time','$app_id','$name','$card_num','$tel','1','$certify_id'", "alipayauth_user_authlog");
        } 
        // 执行短信通知
        $plugin->ide->lzsys_system->run_sms($plugin->ide(), $user_datas, "auth_yes"); 
        // 执行邮件通知
        $plugin->ide->lzsys_system->run_email($plugin->ide(), $user_datas, "auth_yes");
        exit("True");
    } 
    exit($query_id);
} 
/**
 * ------实名认证开始
 */
if ($get['act'] == "auth_api") {
    if ($post['name'] == "") {
        exit("请输入姓名");
    } 
    if ($post['card_num'] == "") {
        exit("请输入身份证");
    } 
    if ($post['tel'] == "") {
        exit("请输入手机号");
    } 
    if ($post['vcode'] == "") {
        exit("请输入手机验证码");
    } 
    $post = $plugin->ide->php->post();
    foreach($post as $k => $v) {
        if ($v == "") {
            $post[$k] = '0';
        } 
    } 
    $vcode = $post['vcode'];
    $tel = $post['tel'];
    $card_num = $post['card_num'];
    $name = $post['name'];
    $smscode = $plugin->ide->php->session("vcode");
    $mobile_tel = $plugin->ide->php->session("mobile");
    if ($vcode <> $smscode) {
        exit("验证码错误");
    } 
    if ($mobile_tel <> $tel) {
        exit("验证码与手机号不匹配");
    } 
    xueauth_vcode_time($plugin); 
    // 进行实名认证操作
    $certifyid = auth_initialize($api_config, $name, $card_num, $tel, $plugin); //取出标识
    $certify_id = $certifyid; //取出标识
    $url = auth_certify($certifyid, $api_config); //请求验证
    $mobiles = $plugin->ide->lzsys_system->mobile();
    $mobile_a = "False";
    $qrcode = "qrcode";
    if ($mobiles == true) {
        $mobile_a = "True";
        $qrcode = "url";
    } 

    $img = '<a style="color:black"><center>请用支付宝扫码实名</center></a><br><img style="width:260px;height:250px;" src="' . "//qrcode.lzsys.com/addon/qrcode/phpqrcode/api.php?url=" . base64_encode($url) . '" />';
    $url = str_replace("amp;", "", $url);
    $data = array("msg" => "True", "type" => $qrcode, "url" => $url, "mobile" => $mobile_a, "img" => $img); 
    // 写实名信息记录日志
    $app_id = $plugin->ide->lzsys_system->app_id();
    $update_time = time();
    $create_time = time();
    $user_id = $plugin->ide->php->session("user_id");

    $auth_logs = $plugin->ide->mysql->get_db("user_id<>'$user_id' and app_id='$app_id' and name='$name' and card_num='$card_num'", "alipayauth_user_authlog");
	if ($auth_logs) {
		// 其他人使用了该实名信息
		exit("实名信息已经被其他账户使用");
	}
	
	#lzsys_alipayauth_user_authlog_api
    $auth_log = $plugin->ide->mysql->get_db("user_id='$user_id' and app_id='$app_id'", "alipayauth_user_authlog");

    if ($auth_log) {
        // 已经存在记录 执行更新
        $plugin->ide->mysql->up_db("certify_id='$certify_id',certify_ids='$certify_id',name='$name',tel='$tel',card_num='$card_num',update_time='$update_time'", "alipayauth_user_authlog", "user_id='$user_id' and app_id='$app_id'");
    } else {
        // 不存在记录 执行写入
        $plugin->ide->mysql->add_db("null,'$user_id','$create_time','$update_time','$app_id','$name','$card_num','$tel','$certify_id','$certify_id'", "alipayauth_user_authlog");
    } 
    exit(json_encode($data));
} 
// 实名认证结束
exit("没有找到要执行的任务");
// $plugin->ide->views->assign("imgs", $ticket_img, true);
